<?php
    require_once(PFAD_ROOT . PFAD_CLASSES . "class.JTL-Shop.Jtllog.php");

   if (isset($oPlugin->oPluginEinstellungAssoc_arr['janolaw_nutzen']) && $oPlugin->oPluginEinstellungAssoc_arr['janolaw_nutzen'] == "Y") {
       if (pruefeALLOWFOPEN()) {
           define("JANOLAW_LOGGING", 0); // Logging, 1 = true, 0 = false
            define("JANOLAW_LOGGING_FILE", PFAD_LOGFILES . "janolaw.log"); // Logging
            define("JANOLAW_TYPE_AGB", "agb");
           define("JANOLAW_TYPE_WRB", "widerrufsbelehrung");
           define("JANOLAW_TYPE_IMP", "impressum");
           define("JANOLAW_TYPE_DAT", "datenschutzerklaerung");
           define("JANOLAW_FORMAT_HTML", "html");
           define("JANOLAW_FORMAT_TEXT", "txt");
           define("JANOLAW_URL", "http://www.janolaw.de/agb-service/shops/");
            
           $nCaching = intval($oPlugin->oPluginEinstellungAssoc_arr['janolaw_intervall']); // Hours

            // Logging
            Jtllog::writeLog("### Plugin Janolaw gestartet => check ...", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
            
           checkJanolaw($oPlugin, $nCaching);
       } else {
           Jtllog::writeLog("Janolaw Update Fehler: allow_url_fopen ist serverseitig nicht aktiv, bitte setzen Sie sich mit Ihrem Hoster in Verbindung.", JTLLOG_LEVEL_ERROR, false, "kPlugin", $oPlugin->kPlugin);
       }
   }
    
    function getNewJanolaw($oPlugin, $cType, $cFormat, $kUpdate, $kSprache)
    {
        // Logging
        Jtllog::writeLog("Update: kUpdate (Janolaw) " . $kUpdate . " - cType " . $cType . " - cFormat " . $cFormat . " - kSprache " . $kSprache . " wird geladen ...", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
                
        // Neue Datei laden
        $cURL = JANOLAW_URL . $oPlugin->oPluginEinstellungAssoc_arr['janolaw_userid'] . "/" . $oPlugin->oPluginEinstellungAssoc_arr['janolaw_shopid'] . "/" . $cType . "_include." . $cFormat;
        if (JANOLAW_FORMAT_TEXT === $cFormat) {
            $cURL = JANOLAW_URL . $oPlugin->oPluginEinstellungAssoc_arr['janolaw_userid'] . "/" . $oPlugin->oPluginEinstellungAssoc_arr['janolaw_shopid'] . "/" . $cType . "." . $cFormat;
        }
        
        // Logging
        Jtllog::writeLog("Hole URL (Janolaw): " . $cURL, JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
        
        $file = @file_get_contents($cURL);
        
        if ($file !== false) {
            $file = $GLOBALS['DB']->escape($file);
            $cSpalte    = "";
            $cTabelle   = "";
            $cSet       = "";
            $kLink      = 0;
            switch ($cType) {
                // AGB
                case JANOLAW_TYPE_AGB:
                    $cSpalte    = "cAGBContentText";
                    $cTabelle   = "ttext";
                    $cWhere     = " kSprache = " . intval($kSprache);
                    if ($cFormat == JANOLAW_FORMAT_HTML) {
                        $cSpalte = "cAGBContentHtml";
                    }
                    break;

                // WRB
                case JANOLAW_TYPE_WRB:
                    $cSpalte    = "cWRBContentText";
                    $cTabelle   = "ttext";
                    $cWhere     = " kSprache = " . intval($kSprache);
                    if ($cFormat == JANOLAW_FORMAT_HTML) {
                        $cSpalte = "cWRBContentHtml";
                    }
                    break;
                    
                // Impressum
                case JANOLAW_TYPE_IMP:
                    $cSpalte    = "cContent";
                    $cTabelle   = "tlinksprache";
                    $oLink      = $GLOBALS['DB']->executeQuery("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_IMPRESSUM, 1);
                    $cWhere     = "cISOSprache = '" . gibSprachKeyISO("", $kSprache) . "' AND kLink = " . $oLink->kLink;
                    break;
                
                // Datenschutz
                case JANOLAW_TYPE_DAT:
                    $cSpalte    = "cContent";
                    $cTabelle   = "tlinksprache";
                    $oLink      = $GLOBALS['DB']->executeQuery("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_DATENSCHUTZ, 1);
                    $cWhere     = "cISOSprache = '" . gibSprachKeyISO("", $kSprache) . "' AND kLink = " . $oLink->kLink;
                    break;
            }

            //Jtllog::writeLog("# Fhre Update aus: UPDATE " . $cTabelle. " SET " . $cSpalte . " = '" . $file . "' WHERE " . $cWhere, JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);

            $GLOBALS['DB']->executeQuery("UPDATE " . $cTabelle. "
                                            SET " . $cSpalte . " = '" . $file . "'
                                            WHERE " . $cWhere, 3);

            $GLOBALS['DB']->executeQuery("UPDATE xplugin_jtl_janolaw_tupdate
                                            SET dAktualisiert = now(),
                                                nVersuch = 0
                                            WHERE kUpdate = " . intval($kUpdate), 3);

            // Logging
            Jtllog::writeLog("(Janolaw) kUpdate: " . $kUpdate . " " . $cType . " " . $cFormat . " wurde aktualisiert.", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
        } else {
            $GLOBALS['DB']->executeQuery("UPDATE xplugin_jtl_janolaw_tupdate
                                            SET nVersuch = nVersuch + 1
                                            WHERE kUpdate = " . intval($kUpdate), 3);
            
            // Logging
            Jtllog::writeLog("(Janolaw) kUpdate " . $kUpdate . " war nicht erfolgreich.", JTLLOG_LEVEL_ERROR, false, "kPlugin", $oPlugin->kPlugin);
        }
    }
    
    // Prueft ob DB noch aktuell ist
    function checkJanolaw($oPlugin, $nCaching)
    {
        $oSprache = $GLOBALS['DB']->executeQuery("SELECT kSprache
                                                    FROM tsprache
                                                    WHERE cISO = 'ger'", 1);
        
        // Logging
        Jtllog::writeLog("(Janolaw) Sprache: " . print_r($oSprache, 1), JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
        
        if (isset($oSprache->kSprache) && $oSprache->kSprache > 0) {
            $oUpdate_arr = $GLOBALS['DB']->executeQuery("SELECT *
                                                            FROM xplugin_jtl_janolaw_tupdate
                                                            WHERE (dAktualisiert = '0000-00-00 00:00:00' OR DATE_ADD(dAktualisiert, INTERVAL " . intval($nCaching) . " HOUR) < now())
                                                                AND nAktiv = 1", 2);
         
            // Logging
            Jtllog::writeLog("(Janolaw) Text: " . print_r($oUpdate_arr, 1), JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
            
            if (count($oUpdate_arr) > 0) {
                foreach ($oUpdate_arr as $oUpdate) {
                    if (isset($oUpdate->kUpdate) && $oUpdate->kUpdate > 0) {
                        if (isset($oUpdate->nVersuch) && $oUpdate->nVersuch >= 999) {
                            $GLOBALS['DB']->executeQuery("UPDATE xplugin_jtl_janolaw_tupdate
                                                            SET nAktiv = 0
                                                            WHERE kUpdate = " . intval($oUpdate->kUpdate), 3);

                            // Logging
                            Jtllog::writeLog("kUpdate (Janolaw) " . $oUpdate->kUpdate . " wurde deaktiviert!", JTLLOG_LEVEL_ERROR, true, "kPlugin", $oPlugin->kPlugin);

                            continue;
                        }
                        
                        // Updaten
                        getNewJanolaw($oPlugin, $oUpdate->cType, $oUpdate->cFormat, $oUpdate->kUpdate, $oSprache->kSprache);
                    }
                }
            }
        }
    }
